if(!org) var org={};
if(!org.mozdev) org.mozdev={};

org.mozdev.getpartialmessages = function(){
  var pub = {};
  pub.getMessages = function(){
    const MSG_FLAG_PARTIAL = 0x400;
  
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                            .getService(Components.interfaces.nsIXULAppInfo);
    var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                                 .getService(Components.interfaces.nsIVersionComparator);
    if(versionChecker.compare(appInfo.version, "3.0b3") >= 0) {
      var view = gDBView;
      var fldrlocal = view.getFolderForViewIndex(0);
      var messagesEnumerator = fldrlocal.messages;
    }
    else if (versionChecker.compare(appInfo.version, "3.0a1pre") < 0) {
      var view = GetDBView();
      var fldrlocal = view.getFolderForViewIndex(0);
      var messagesEnumerator = fldrlocal.getMessages(null);
    }
    else {
      return;
    }
    
    var flaggedMessages = new Array();
    
    view.selectMsgByKey(null);
      
     while (messagesEnumerator.hasMoreElements()) {
        var message = messagesEnumerator.getNext();
        var messageHeader = message.QueryInterface(Components.interfaces.nsIMsgDBHdr);
      if (messageHeader.isFlagged) {
        flaggedMessages.push(messageHeader.messageKey);      
       }
        view.selectMsgByKey(messageHeader.messageKey);
        view.doCommand(Components.interfaces.nsMsgViewCommandType.unflagMessages);
        if (messageHeader.flags & MSG_FLAG_PARTIAL){
          view.selectMsgByKey(messageHeader.messageKey);
          view.doCommand(Components.interfaces.nsMsgViewCommandType.flagMessages);
      }
    }
  
    view.doCommand(Components.interfaces.nsMsgViewCommandType.selectFlagged);
    if (view.selection.count > 0) {  
      goDoCommand('cmd_downloadFlagged');
    }    
    view.doCommand(Components.interfaces.nsMsgViewCommandType.selectFlagged);
    view.doCommand(Components.interfaces.nsMsgViewCommandType.unflagMessages);
  
    for (var i in flaggedMessages) {
        view.selectMsgByKey(flaggedMessages[i]);
        view.doCommand(Components.interfaces.nsMsgViewCommandType.flagMessages);
    }
    view.selectMsgByKey(null);
  }
  return pub;
}();